% Fill in default parameters for the GPIRL algorithm.
function algorithm_params = gpirldefaultparams(algorithm_params)

% Create default parameters.
default_params = struct(...
    'seed',0,...
    ...% Optional initial values.
    'initial_r',[],...
    'initial_gp',[],...
    ...% Which parameters to learn.
    'warp_x',0,...
    'learn_noise',0,...
    'learn_rbf',1,...
    ...% Parameters for random restarts.
    'restart_tolerance',1e1,...
    'initial_rewards',5,...
    'warp_x_restarts',4,...
    ...% These are hyperparameter transformations for positivity constraints.
    'ard_xform','exp',...
    'noise_xform','exp',...
    'rbf_xform','exp',...
    'warp_l_xform','exp',...
    'warp_c_xform','exp',...
    'warp_s_xform','exp',...
    ...% These are hyperparameter priors.
    'ard_prior','logsparsity',...
    'noise_prior','g0',...
    'rbf_prior','none',...
    'warp_l_prior','g0',...
    'warp_c_prior','gamma',...
    'warp_s_prior','g0',...
    ...% These are prior wights and parameters.
    'ard_prior_wt',1,...
    'noise_prior_wt',1,...
    'rbf_prior_wt',1,...
    'warp_l_prior_wt',1,...
    'warp_c_prior_wt',0.5,...
    'warp_s_prior_wt',1,...
    'gamma_shape',2,...
    ...% These are initial values.
    'ard_init',1,...
    'noise_init',1e-2,...
    'rbf_init',5,...
    'warp_c_init',2.0,...
    'warp_l_init',1,...
    'warp_s_init',1,...
    ...% These parameters control how the inducing points are selected.
    'inducing_pts','examplesplus',...
    'inducing_pts_count',64);

% Set parameters.
algorithm_params = filldefaultparams(algorithm_params,default_params);
